<template>
    <div class="container">
        
        <h1 class="h1 margin-top">Producto </h1>
        <NuxtLink to="/product">&#60; Ver productos.</NuxtLink>
        <div>
            <form @submit.prevent="submitForm">
                <table class="table" width="500px">
                    <tr>
                        <td width="150px">Nombre</td>
                        <td>
                            <input type="text" name="nombre" v-model="productInfo.nombre" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Descripción</td>
                        <td>
                            <textarea name="descripcion" v-model="productInfo.descripcion" cols="30" rows="5"></textarea>
                        </td>
                    </tr>
                    <tr>
                        <td>Cantidad disponible	</td>
                        <td>
                            <input type="number" name="cantidadDisponible" v-model="productInfo.cantidadDisponible" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Precio Unitario</td>
                        <td>
                            <input type="text" name="precioUnitario" v-model="productInfo.precioUnitario" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Proveedor</td>
                        <td>
                            <input type="text" name="proveedor" v-model="productInfo.proveedor" autocomplete="off" />
                        </td>
                    </tr>
                </table>
                <div>
                    <input type="submit" class="btn btn-primary" :value="currentAction.name" />
                </div>
            </form>
        </div>

    </div>
</template>
<script lang="ts" setup>
import { baseActionDetection } from '~/server/utils/forms/actionsDetector';

    const routerInstance = (useRouter());
    const id = ref(routerInstance.currentRoute.value.params.id.toString());
    let currentAction = ref(baseActionDetection(parseInt(id.value), routerInstance.currentRoute.value));

    const productInfo = ref({
        id: 0,
        nombre: '',
        descripcion: '',
        cantidadDisponible: '',
        precioUnitario: '',
        proveedor: '',
    });

    console.log(currentAction.value);

    if (currentAction.value.index !== 0) {
        findItemById(parseInt(id.value));
    }

    async function findItemById(id: number) {
        productInfo.value = await $fetch(`/api/product?id=${id}`, {   
            method: 'GET',
            headers: { 'method': 'findRecord' }
        });
    }

    async function submitForm() {
        let r = await $fetch(`/api/product`, {   
            method: 'POST',
            body: productInfo.value,
            headers: { 'method': currentAction.value.method }
        });
        navigateTo('/product');
    }
</script>
